var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import mitt from 'mitt';

var Store = function () {
  function Store(initialState) {
    _classCallCheck(this, Store);

    this._state = initialState;
    this.events = mitt();
    this.on = this.events.on;
    this.off = this.events.off;
    this.emit = this.emit.bind(this);
    this.addReducer = this.addReducer.bind(this);
  }

  Store.prototype.emit = function emit(type, payload) {
    if (typeof type === 'function') return type(this.emit, this.state);
    this.events.emit(type, payload);
  };

  Store.prototype.addReducer = function addReducer(reducer) {
    var _this = this;

    var _loop = function _loop(type) {
      var handler = void 0;
      handler = function handler(eventType, e) {
        if (eventType.substring(0, 6) === 'store:') return;
        _this.state = reducer[type](_this.state, e, eventType) || _this.state;
        _this.events.emit('store:change', _this.state);
      };
      if (type !== '*') {
        handler = handler.bind(null, type);
      }
      _this.events.on(type, handler);
    };

    for (var type in reducer) {
      _loop(type);
    }
  };

  _createClass(Store, [{
    key: 'state',
    get: function get() {
      return this._state;
    },
    set: function set(nextState) {
      this._state = nextState;
    }
  }]);

  return Store;
}();

export function createStore(initialState) {
  return new Store(initialState);
}